''*****************************
''*  Graphics Demo            *
''*  (C) 2005 Parallax, Inc.  *
''*****************************


CON
  nx=220   ' active pixel display
  ny=160
  nxd=20 'division unit in pxels
  nyd=20
  tickL=10 ' lenght of the tick
 'do not touch those below, came w/ graphic driver
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  _stack = ($3000 + $3000 + 100) >> 2   'accomodate display memory and stack
  x_tiles = 16
  y_tiles = 12
  paramcount = 14       
  bitmap_base = $2000
  display_base = $5000

   '.... ADC383
  pinCLK=3
  pinCS=4
  pinDIDA=1
  
   '..... sonar 
   pinSonarInp=16 ' burst
   pinSonarOut=17 ' echo  

   cr=13 'carrage return
  pinTV=12

   
  '.... general control
  drawMode=1 ' 0=not erase old location, 1 =refresh
 
VAR
 ' uses pin=12 for TV 

'do not touch those below, came w/ graphic driver
  long  tv_status     '0/1/2 = off/visible/invisible           read-only
  long  tv_enable     '0/? = off/on                            write-only
  long  tv_pins       '%ppmmm = pins                           write-only
  long  tv_mode       '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long  tv_screen     'pointer to screen (words)               write-only
  long  tv_colors     'pointer to colors (longs)               write-only               
  long  tv_hc         'horizontal cells                        write-only
  long  tv_vc         'vertical cells                          write-only
  long  tv_hx         'horizontal cell expansion               write-only
  long  tv_vx         'vertical cell expansion                 write-only
  long  tv_ho         'horizontal offset                       write-only
  long  tv_vo         'vertical offset                         write-only
  long  tv_broadcast  'broadcast frequency (Hz)                write-only
  long  tv_auralcog   'aural fm cog                            write-only

  word  screen[x_tiles * y_tiles]
  long  colors[64]
  '.... klman
    long t0,t1   
  
OBJ
  tv    : "tv"
  gr    : "graphics"
  tvt: "TV_text"
  adc   : "J-ADC838x" 
  son: "J-SonarSFR04-v2x"
  kal: "J-Kal-ver2x"    '***HERE***
    
PUB start | i, k ,dx,dy,y1,x1,ex1,errKal

  '......start tv
  longmove(@tv_status, @tvparams, paramcount)
  tv_screen := @screen
  tv_colors := @colors
  tv.start(@tv_status)

  'init colors
  repeat i from 0 to 63
    colors[i] := $00001010 * (i+4) & $F + $2B060C02

  'init tile screen
  repeat dx from 0 to tv_hc - 1
    repeat dy from 0 to tv_vc - 1
      screen[dy * tv_hc + dx] := display_base >> 6 + dy + dx * tv_vc + ((dy & $3F) << 10)
      
  '.........start and setup graphics
  gr.start
  gr.setup(16, 12, 20, 20, bitmap_base)
  gr.clear   'clear bitmap  
  drawFrame

  '........ start ADC
  if adc.init(pinCS,pinCLK,pinDIDA)
    textMode  
    tvt.str(string("Error in pin assignemnt,STOP",cr)) 
    abort

  '..... start SONAR  
  son.setPins(pinSonarInp,pinSonarOut)
  son.use_100cm

   '..... start KALMAN
  ' kal.start  '***HERE***

  '.... event loop      
  repeat i from 0 to 50000
     if drawMode>0
         gr.clear   'clear bitmap  
         drawFrame
     dx:=adc.read(0)/2  'reduced X-value
     dy:=adc.read(1)/2  'reduced Y-value
     t1:=cnt
     y1:=son.distance
     if dx<10 and dy<10
        textMode  
        tvt.str(string("Hot LL corner --> STOP",cr)) 
        abort
     
     gr.plot(dx,dy)
     gr.copy(display_base)
     'waitcnt(5_0_000+cnt)
    
pub drawFrame  |i  ,numchr,d
   { x=y=0 is in the cross-point of LL grid  }
   
    gr.color(2)
  'draw X-axis       
   gr.plot(0,0)       
   gr.line(nx,0)
   repeat i from 0 to nx/nxd
      d:=i*nxd
      gr.plot(d,ny)        
      gr.line(d,-tickL)
      
 ''draw Y-axis      
   gr.plot(0,0)       
   gr.line(0,ny)
   repeat i from 0 to ny/nyd
      d:=i*nyd
      gr.plot(nx,d)        
      gr.line(-tickL,d)

   drawCorners
   gr.color(1)
   'draw pix map of dog
   gr.width(0) 
  return
pub textMode
  gr.stop
  tv.stop
  tvt.start(pinTV)  'initialize TV
  tvt.str(string("==Revert to text mode==",cr))
return
  
pub drawCorners { @ x,y =0, 128 }
   gr.color(2)         
   gr.plot(20,0) '.....LL      
   gr.line(0,20)
   gr.plot(110,0) '.....LR      
   gr.line(130,20)
   gr.plot(20,130) '.....TL      
   gr.line(0,110)
   gr.plot(110,130) '.....TR      
   gr.line(130,110)
   
DAT

tvparams                long    0               'status
                        long    1               'enable
                        long    %001_0101       'pins
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    x_tiles         'hc
                        long    y_tiles         'vc
                        long    10              'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    0               'broadcast
                        long    0               'auralcog

